
% COM=initXBeeSerial('COM1',115200);
% fopen(COM);
% disp('port opened');figure(1)

%This script will wait for XBee packets and plot the data in them in real
%time.  It expects that teh serial port is already open; run the
%open_serial.m script to open the serial port.  Then run this script.  Hit
%'q' to quit.  After quitting, run the close_serial.m script if you don't
%plan to run the script again.
figure(1)
axis equal
xlim([-1200 1200])
ylim([-1200 1200])
%Set DRAW_SWARM_STATS = 1 to draw the average ellipse.
DRAW_SWARM_STATS = 1;

statsCounter = 1;
statsCounterLim = 10;
statsRunningSum = [0 0 0 0 0];
statsAvg = [0 0 0 0 0];
swarmEllipseH = -1;
swarmCMH = -1;

ellipseH=-1*ones(1,20);
labelH=-1*ones(1,20);
targetEllipseH = -1;
targetCMH = -1;

[targetEllipseH targetCMH]  = drawellipse(100,300,160000,40000,40000,'k');
currentEllipse = [100 300 160000 40000 40000];

while (1)
    keypress = keyinfo; %keyinfo.dll written by Fusung Wang from MATLAB Central
    if keypress(1) == 81;
        break;
    end
% 	wait for data
    while(COM.BytesAvailable<100)
        keypress = keyinfo; %keyinfo.dll written by Fusung Wang from MATLAB Central
        if keypress(1) == 81;
            break;
            endq
    end
    [packet ErrorFlag]=getXBeePacket(COM);
    disp(i);
    
%   parse packet
    if ~ErrorFlag
        switch packet.source
            case 1
                color = [1 0.5 0];
            case 2
                color = [0 1 0];
            case 3
                color = [0 0 1];
            case 4
                color = [.5 .5 0];
            case 5
                color = [1 0 1];
            case 6
                color = [0 1 1];
            case 7
                color = [0.6 0.3 0.6];
            case 8
                color = [0 .5 .5];
            case 9
                color = [.5 0 .5];
            otherwise
                disp('unknown robot ID');
        end

        if packet.source ~= 0 %if the source is not the computer
            if labelH(packet.source) ~= -1  %delete old ellipse if exists.
                delete(labelH(packet.source));
                delete(ellipseH(packet.source));
            end
            labelH(packet.source) = text(packet.data(11),packet.data(12),sprintf('%i',packet.source),'color',color);
            ellipseH(packet.source) = drawellipse_fast(packet.data(1),packet.data(3),packet.data(5)-packet.data(1)^2,packet.data(7)-packet.data(1)*packet.data(3),packet.data(9)-packet.data(3)^2,color);
        else %IF source == 0
            switch packet.data(1)
                case 3
                    if targetEllipseH ~= -1
                        delete(targetEllipseH);
                        delete(targetCMH);
                    end
                    currentEllipse(1:5) = [packet.data(2) packet.data(3) packet.data(4) packet.data(5) packet.data(6)];
                    [targetEllipseH targetCMH] = drawellipse(currentEllipse(1),...
                                                        currentEllipse(2),...
                                                        currentEllipse(3),...
                                                        currentEllipse(4),...
                                                        currentEllipse(5),...
                                                        [0 0 0]);
                case 4
                    if targetEllipseH ~= -1
                        delete(targetEllipseH);
                        delete(targetCMH);
                    end
                    currentEllipse(1:2) = [packet.data(2) packet.data(3)];
                    [targetEllipseH targetCMH] = drawellipse_fast(currentEllipse(1),...
                                                        currentEllipse(2),...
                                                        currentEllipse(3),...
                                                        currentEllipse(4),...
                                                        currentEllipse(5),...
                                                        [0 0 0]);                   
                otherwise
            end                                   
        end
    end %if ~ErrorFlag
    
    if DRAW_SWARM_STATS==1
%         Draw swarm average ellipse
        if statsCounter==statsCounterLim
            statsCounter = 1;
            if swarmEllipseH ~= -1
                    delete(swarmEllipseH);
                    delete(swarmCMH);
            end
            statsAvg = statsRunningSum/statsCounterLim;
            [swarmEllipseH swarmCMH] = drawellipse(statsAvg(1),...
                                        statsAvg(2),...
                                        statsAvg(3)-statsAvg(1)^2,...
                                        statsAvg(4)-statsAvg(1)*statsAvg(2),...
                                        statsAvg(5)-statsAvg(2)^2,...
                                        'r');
            statsRunningSum = [0 0 0 0 0];

        else
            statsRunningSum = statsRunningSum + [packet.data(1) packet.data(3) packet.data(5) packet.data(7) packet.data(9)];
            statsCounter=statsCounter+1;
        end %if statsCounter == statsCounterLim
    end  %if drawSwarmStats==1
    
    
    if (COM.BytesAvailable>2000)
        fread(COM, COM.BytesAvailable);
        disp('Buffer Flushed');
    end
end  %while(1)

% fclose(COM)
% delete(COM)
% clear COM